/*
   filter.c

   Program to convert all characters to upper or lower case,
   depending on the name of the program (toupper, tolower).

   (C) Copyright, 1992 by Rijksuniversiteit Leiden.

   Version: 1.0
   Date   : 27.11.92
   Disk   : C:\TMP\CURSUS
   Author : M.J. Moene

   Compiler        : Borland-C++ 2.0
   Operating system: MS-DOS Version 5.00
   Hardware system : PC XT, AT
*/

/* Filter
 *
 *		  +----------+
 *		  |          |
 *	stdin --->|  filter  |---> stdout
 *		  |          |
 *		  +----------+
 *                      ^
 *			|
 *	     [ commandline arguments ]
 */

/*------------------------------------------------------------------------------
**  included files
**------------------------------------------------------------------------------
*/

#include <ctype.h>				/* for tolower, toupper	    */
#include <stdio.h>				/* for getchar, putchar	    */
#include <string.h>				/* for strcmp, strstr	    */


/*------------------------------------------------------------------------------
**  main function
**------------------------------------------------------------------------------
*/

#pragma argsused				/* argc never used	    */

int main(int argc, char *argv[])
{
   int   chr;
   char *prog              = strrchr( strlwr(argv[0]), '\\') + 1;
   int (*convert)(int chr) = (strstr(prog, "tolower") != 0) ? tolower : toupper;

   while ( (chr = getchar()) != EOF )
   {
      if ( EOF == putchar( (*convert)(chr) ) )	/* also: convert(chr)	    */
      {
	 fprintf(stderr, "%s: error writing file.\n", prog);
	 return 1;
      }
   }

   return 0;
}


/*** End of file ***/
